<template>
  <PageWrapper>
    <el-card :bordered="false" class="pt-3 mb-3 proCard">
      <BasicForm @register="register" @submit="handleSubmit" @reset="handleReset"></BasicForm>
    </el-card>
    <el-card :bordered="false" class="proCard">
      <BasicTable
        :columns="columns"
        :request="loadDataTable"
        :row-key="(row) => row.id"
        ref="tableRef"
        :actionColumn="actionColumn"
         @selection-change="onSelectionChange"
      >
        <template #tableTitle>
          <el-button type="danger" @click="handleDelete()" :disabled="!selectionData.length" v-perm="['sys:operlog:batchDelete']">
              <template #icon>
                <el-icon class="el-input__icon">
                  <Delete />
                </el-icon>
              </template>
              删除
            </el-button>
        </template>
      </BasicTable>
    </el-card>

    <editDialog
        v-if="editVisible"
        :operlogId="operlogId"
        v-model:visible="editVisible"
        @success="reloadTable('noRefresh')"
    >
    </editDialog>
  </PageWrapper>
</template>

<script lang="ts" setup>
  import { reactive, ref, h,nextTick,defineAsyncComponent } from 'vue';
  import { ColProps } from 'element-plus';
  import { schemas } from './operLog/querySchemas';
  import { useForm } from '@/components/Form/index';
  import { TableAction } from '@/components/Table';
  import { getOperLogList,operLogDelete,operLogBatchDelete } from '@/api/system/operLog';
  import { columns } from './operLog/columns';
  import {message,confirm} from "@/utils/auth";
  const editDialog = defineAsyncComponent(() =>
    import('./operLog/edit.vue')
)
const operlogId =ref(0)
const editVisible=ref(false)
  const selectionData = ref([])
  const tableRef = ref();
  const formParams = reactive({
    type:'',
    status:''
  });
  const actionColumn = reactive({
    width: 250,
    label: '操作',
    prop: 'action',
    fixed: 'right',
    render(record) {
      return h(TableAction, {
        style: 'button',
        actions: [
          {
            label: '详情',
            icon:'View',
            type: 'warning',
            onClick: handleInfo.bind(null, record),
            auth: ['sys:operlog:detail'],
          },
          {
            label: '删除',
            icon:'Delete',
            type: 'danger',
            onClick: handleDelete.bind(null, record),
            auth: ['sys:operlog:delete'],
          },
        ],
      });
    },
  });

  const loadDataTable = async (res: any) => {
    const result = await getOperLogList({ ...formParams, ...res });
    return result;
  };

  function reloadTable(noRefresh='') {
    tableRef.value.reload(noRefresh?{}:{pageNo:1});
  }
  const [register, {}] = useForm({
    labelWidth: 80,
    layout: 'horizontal',
    colProps: { span: 6 } as ColProps,
    submitOnReset:true,
    schemas
  });
  function handleSubmit(values: Recordable) {
    handleReset()
    for (const key in values) {
      formParams[key] = values[key]
    }
    reloadTable();
  }

  function handleReset() {
    for (const key in formParams) {
        formParams[key] ='';
    }
  }
const handleInfo = async (record: Recordable) => {
  operlogId.value=record.row.id
  await nextTick();
  editVisible.value=true
};

async function handleDelete(record: Recordable) {
    let ids = []
    if(!record){
      ids = selectionData.value.map(({id}) => id);
    }
    await confirm('确定要删除？');
    record? await operLogDelete(record.row.id):await operLogBatchDelete(ids);
    message("删除成功");
    reloadTable()
  }
function onSelectionChange(value){
    selectionData.value = value
  }
</script>

<style lang="scss" scoped></style>
